/* Tommi Harkanen (C) 2000 */
/* Read the file copyright.txt for details */


/* ------- GENERAL3.H ------- */
#include "typedef.h"

void prnI(long n, long *vec);
void prnD(long n, double *vec);
void intToChar(long x, char res[6]);
void doubleToChar(double x, char res[20]);
long stringToD(char *number, double *dRes);
void dtoasc(double x, char *str);
long numeric(char dum);
long aritmeticOp(char dum);
long specialChar(char dum);
void readLine(FILE *fp, char line[80]);
void orderDValues(long n, double *values);

void printMatrix(long n, double **a);
void cholesky(long dim, double **a, double **m);
void invMatrix2(long n, double **a, double **b);
double determinant(long n, double *m);
void invMatrix(long n, double *a, double *b);

double factorial(long arg);
double ran_uni(double low, double hi);
double ran_exp(double lambda);
double ran_gamma1(double alpha);
double ran_gamma(double alpha,double beta);
double reject_gamma(double alpha, double prev, double next);
long ran_poi(double mu);
double ran_poiPr(sf mu, double x, double x2);
double cos_distr_f(double r, double d);
double gen_cos(double d);
double ran_norm();
double ran_student(double mu, double var, double df);
double log_gamma(double x);
double log_gamma_nrm(double alpha, double beta);
double log_dens_gamma(double x, double alpha, double beta);
double dens_gamma(double x, double alpha, double beta);
sf poiProcess(double a, double b, double mu, double minPieceLength, sf old);
void levelsG(sf f, double alpha0, double beta0, double alpha, double beta, double restrict0); 
void levelsGL(mf model_f, sf f, double alpha0, double beta0, double alpha, double beta,
	      double *lexis_weight);
void levelsG2(sf f, double alpha0, double beta0, double alpha, double restrict0);
void levelsIG(sf f, double alpha0, double beta0, double alpha, double beta, 
	     double restrict0);
void levelsDG(sf f, double alpha0, double beta0, double restrict0);
void levelsPD(sf f, double a, double w, double restrict0);
double dens_norm(double x, double a, double w);
/*double gamma(double x);*/
double probit(double x, double mu, double sigma);

