/* Tommi Harkanen (C) 2000 */
/* Read the file copyright.txt for details */

#ifndef LOAD
#define LOAD
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "typedef.h"
#include "sf3.h"
#include "general3.h"
#include "prior.h"
#include "ftree.h"
#include "bit.h"
#include "load.h"
#include "pipefiles.h"

extern long nextCar, nextI, lineno;
extern double missing;
extern dt d;
extern ct c;

/* Some functions for reading data. */

/* typedef struct dn *dataNode;

struct dn {
  long ind;
  long car;
  long mark;
  long type;
  long storage;
  double begin;
  double end;
  long nObs;
  double *cData;
  long *dData;
} dN; 

typedef struct cn *covNode;

struct cn {
  char name[20];
  long ind;
  long car;
  long type;
  double cnst;
  sf f;
  long n;
  long storage;
  double *sp;
} cN; */

/* long printLevel = 1;

void main()
{
  dataNode *d;
  covNode *c;
  long i, j, ind = 245, dim, car = 0;
  char **text;

  d = initData(245, 2);
  dim = dataCars(d);
  loadData("epil.dat", 1, ind, car, -999, d); 
  c = initCov(245, 2);
  dim = covCars(c);
  loadCov("birth.dat", "birth", ind, COV_START, -999, c);
  loadCov("sex.dat", "sex", ind, COV_CNST, -999, c);
  for (i = 0; i < ind; i++) {
    bite_printf("%ld: %ld %ld %ld, %f %f %ld %ld ", i, d[i * dim + car]->ind, 
	   d[i * dim + car]->mark, d[i * dim + car]->type,
	   d[i * dim + car]->begin, d[i * dim + car]->end, 
	   d[i * dim + car]->nObs, d[i * dim + car]->storage);
    for (j = 0; j < d[i * dim + car]->nObs; j++)
      bite_printf("%ld", d[i * dim + car]->dData[j]); 
    bite_printf("%ld: %f %f", i, c[i * dim]->sp[0], c[i * dim + 1]->cnst);
    bite_printf("\n");
  }
  text = (char **)(malloc( ind * sizeof( *d ) ) );
  covLevels(c, "sex", 245, &j, text);
  for (i = 0; i < j; i++)
    bite_printf("%ld: %s\n", i, text[i]);
} */

/* long dataCars(dataNode **d)
{
  long dim = 1;

  while (d[dim]->car != d[0]->car)
    dim++;
  return(dim);
} */

long findResponce(char *name)
{
  long i = 0;

  while (strcmp(d->dList[i][0][0]->name, name) && i < d->n)
    i++;
  if (i == d->n) {
    bite_eprintf( "%s: no such responce.\n", name);
    bite_exit(1);
  }

  return i;
}

long findCovariate(char *name)
{
  long i = 0;

  while (strcmp(c->cList[i][0]->name, name) && i < c->n)
    i++;
  if (i == c->n) {
    bite_eprintf( "%s: no such responce.\n", name);
    bite_exit(1);
  }

  return i;
}

/* void loadData(char *fileName, char *name, long mark, long ind, long car, 
	      long nextI, dt d)
{
  FILE *datap;
  long i, j, max = 0;
  double fl, a, b, m;
  dataNode **dd;
  prior ptr, last;

  if ((datap = bite_fopen(fileName, "r")) == NULL) {
    bite_printf("Unable to open file %s\n", fileName);
    bite_exit(1);
  }

  if (d->pList[mark]) {
    strcat(d->dList[mark][0][0]->name, name);
    d->dList[mark][0][0]->ind = 0;
    d->dList[mark][0][0]->mark = mark;
    d->dList[mark][0][0]->type = CONT;
    for (i = 0; i < ind; i++) {
      if (d->pList[mark]->n2[i] < car)
	d->pList[mark]->n2[i] = car + 1;
      fscanf(datap, "%lf %lf %lf", &fl, &a, &b);
      d->pList[mark]->val.pp.t0[i][car] = a;
      d->pList[mark]->fixed.pp.t0[i][car] = (a != missing) ? TRUE : FALSE;
      d->pList[mark]->val.pp.t1[i][car] = b;
      d->pList[mark]->fixed.pp.t1[i][car] = (b != missing) ? TRUE : FALSE;
      fscanf(datap, "%lf", &fl);
      j = 1;
      while (fl != nextI) {
	if (!d->pList[mark]->val.pp.npoints[i][car]) {
	  d->pList[mark]->val.pp.points[i][car] =
	    malloc(j * sizeof(fl));
	  d->pList[mark]->fixed.pp.points[i][car] =
	    malloc((j / LONGLEN + 1) * sizeof(i));
	}
	if (d->pList[mark]->val.pp.npoints[i][car] >= j - 1) {
	  d->pList[mark]->val.pp.points[i][car] =
	    realloc(d->pList[mark]->val.pp.points[i][car], j * sizeof(fl));
	  d->pList[mark]->fixed.pp.points[i][car] =
	    realloc(d->pList[mark]->fixed.pp.points[i][car],
		    (j / LONGLEN + 1) * sizeof(i));
	}
	if (fl != missing)
	  putBitTo1(i % LONGLEN,
		    &d->pList[mark]->fixed.pp.points[i][car][j / LONGLEN]);
	else
	  putBitTo0(i % LONGLEN,
		    &d->pList[mark]->fixed.pp.points[i][car][j / LONGLEN]);
	d->pList[mark]->val.pp.points[i][car][j - 1] = fl;
	d->pList[mark]->val.pp.npoints[i][car] = j;
	j++;
	fscanf(datap, "%lf", &fl);
      }
      d->pList[mark]->val.pp.npoints[i][car] = j - 1;
      if (max < j - 1)
	max = j - 1;
    }
    d->pList[mark]->distr.pp.points[car] = malloc(max * sizeof(d));
    d->pList[mark]->distr.pp.npoints[car] = d->nCars[mark];
    for (j = 0; j < max; j++)
      d->pList[mark]->distr.pp.points[car][j] = NULL;
  }
  else {
    dd = d->dList[mark];
    for (i = 0; i < ind; i++) {
      strcat(dd[i][car]->name, name);
      dd[i][car]->ind = i;
      dd[i][car]->mark = mark;
      fscanf(datap, "%ld", &dd[i][car]->type);
      if (dd[i][car]->type == CONT) {
	if (!dd[i][car]->pp) {
	  dd[i][car]->pp = (pProcess) malloc(sizeof(jackPp));
	  dd[i][car]->pp->t0 = NULL;
	  dd[i][car]->pp->t1 = NULL;
	  dd[i][car]->pp->vector = NULL;
	}
	fscanf(datap, "%lf", &fl);
	dd[i][car]->pp->t0 = initPrior("t0");
	dd[i][car]->pp->t0->ptype = PT_CONST;
	dd[i][car]->pp->t0->x->x = (double)fl;
	if ((double)fl != missing)
	  dd[i][car]->pp->t0->fixed = TRUE;

	fscanf(datap, "%lf", &fl);
	dd[i][car]->pp->t1 = initPrior("t1");
	dd[i][car]->pp->t1->ptype = PT_CONST;
	dd[i][car]->pp->t1->x->x = (double)fl;
	if ((double)fl != missing)
	  dd[i][car]->pp->t1->fixed = TRUE;

	dd[i][car]->precision = 0.0;
	fscanf(datap, "%lf", &fl);
	j = 0;
	dd[i][car]->nObs = 0;
	last = dd[i][car]->pp->vector = NULL;
	while ((double)fl != nextI) {
	  ptr = initPrior("point");
	  ptr->ptype = PT_CONST;
	  ptr->x->x = (double)fl;
	  if ((double)fl != missing)
	    ptr->fixed = TRUE;
	  putPrior(last, ptr);
	  if (!dd[i][car]->pp->vector)
	    dd[i][car]->pp->vector = ptr;
	  last = ptr;
	  fscanf(datap, "%lf", &fl);
	}
      }
      else {
	double prec = 0.0;
	fscanf(datap, "%lf", &fl);
	dd[i][car]->begin = (double)fl;
	fscanf(datap, "%lf", &fl);
	dd[i][car]->end = (double)fl;
	fscanf(datap, "%lf", &m);
	j = 0;
	dd[i][car]->nObs = 0;
	while (m != nextI) {
	  addData(dd[i][car], m);
	  fscanf(datap, "%lf", &m);
	  if (dd[i][car]->type == DISCR3 && m != nextI) {
	    dd[i][car]->times[dd[i][car]->nObs - 1] = m;
	    if (m > prec)
	      prec = 0.0;
	    fscanf(datap, "%lf", &m);
	  }
	}
	dd[i][car]->precision = (dd[i][car]->type != DISCR3) ?
	  (dd[i][car]->end - dd[i][car]->begin) / dd[i][car]->nObs : prec;
      }
    }
  }
  fclose(datap);
} */

void loadData2(char *fileName, char *name, long mark, long ind)
{
  FILE *datap;
  long i, j, max = 0, car;
  double fl, a, b;
  /* dataNode **dd; */
  paramVector dd = d->pList[mark];

  if ((datap = bite_fopen(fileName, "r")) == NULL) {
    bite_printf("Unable to open file %s\n", fileName);
    bite_exit(1);
  }

  if (dd) {
    d->dList[mark][0][0]->name[0] = '\0';
    sprintf(d->dList[mark][0][0]->name, "%s", name);
    dd->name = malloc(strlen(name) + 1);
    sprintf(dd->name, "%s", name);
    d->dList[mark][0][0]->ind = 0;
    d->dList[mark][0][0]->mark = mark;
    d->dList[mark][0][0]->type = CONT;
    for (i = 0; i < ind; i++) {
      car = 0;
      fl = 0.5 * (nextI + nextCar);
      fl = readFileD2(datap);
      while (fl != nextI) {
	if (dd->n2[i] == car) {
	  /* Allocate more memory */
	  if (dd->stor == car) {
	    dd->stor++;  
	    dd->distr.pp.npoints =
	      realloc(dd->distr.pp.npoints, dd->stor * sizeof(d));
	    dd->distr.pp.t0 = realloc(dd->distr.pp.t0, dd->stor * sizeof(d));
	    dd->distr.pp.t1 = realloc(dd->distr.pp.t1, dd->stor * sizeof(d));
	    dd->distr.pp.points =
	      realloc(dd->distr.pp.points, dd->stor * sizeof(d));
	    dd->distr.pp.npoints[dd->stor - 1] = 1;
	    dd->distr.pp.t0[dd->stor - 1] = NULL;
	    dd->distr.pp.t1[dd->stor - 1] = NULL;
	    /* dd->distr.pp.points[dd->stor - 1] = malloc(1 * sizeof(d)); */
	  }
	  dd->val.pp.npoints[i] =
	    realloc(dd->val.pp.npoints[i], (car + 1) * sizeof(i));
	  dd->val.pp.nstor[i] =
	    realloc(dd->val.pp.nstor[i], (car + 1) * sizeof(i));
	  dd->val.pp.t0[i] =
	    realloc(dd->val.pp.t0[i], (car + 1) * sizeof(missing));
	  dd->val.pp.t1[i] =
	    realloc(dd->val.pp.t1[i], (car + 1) * sizeof(missing));
	  dd->val.pp.points[i] =
	    realloc(dd->val.pp.points[i], (car + 1) * sizeof(d));

	  dd->fixed.pp.t0[i] =
	    realloc(dd->fixed.pp.t0[i], (car + 1) * sizeof(d));
	  dd->fixed.pp.t1[i] =
	    realloc(dd->fixed.pp.t1[i], (car + 1) * sizeof(d));
	  dd->fixed.pp.points[i] =
	    realloc(dd->fixed.pp.points[i], (car % LONGLEN + 1) * sizeof(d));
	  dd->val.pp.npoints[i][car] = 0;
	  dd->val.pp.points[i][car] = NULL;

	  dd->fixed.pp.t0[i][car] = FALSE;
	  dd->fixed.pp.t1[i][car] = FALSE;
	  dd->fixed.pp.points[i][car] = NULL;

	  dd->n2[i]++;
	}
	dd->val.pp.t0[i][car] = a = readFileD2(datap);
	dd->fixed.pp.t0[i][car] = (a != missing) ? TRUE : FALSE;
	dd->val.pp.t1[i][car] = b = readFileD2(datap);
	dd->fixed.pp.t1[i][car] = (b != missing) ? TRUE : FALSE;
	fl = readFileD2(datap);
	/* bite_printf("%g == 2\n", fl); */
	j = 1;
	while (fl != nextI && fl != nextCar) {
	  if (!dd->val.pp.npoints[i][car]) {
	    dd->val.pp.points[i][car] =
	      malloc(j * sizeof(fl));
	    dd->fixed.pp.points[i][car] =
	      malloc((j / LONGLEN + 1) * sizeof(i));
	  }
	  if (dd->val.pp.npoints[i][car] >= j - 1) {
	    dd->val.pp.points[i][car] =
	      realloc(dd->val.pp.points[i][car], j * sizeof(fl));
	    dd->fixed.pp.points[i][car] =
	      realloc(dd->fixed.pp.points[i][car],
		      (j / LONGLEN + 1) * sizeof(i));
	  }
	  if (fl != missing)
	    putBitTo1(i % LONGLEN,
		      &dd->fixed.pp.points[i][car][j / LONGLEN]);
	  else
	    putBitTo0(i % LONGLEN,
		      &dd->fixed.pp.points[i][car][j / LONGLEN]);
	  dd->val.pp.points[i][car][j - 1] = fl;
	  dd->val.pp.npoints[i][car] = j;
	  j++;
	  fl = readFileD2(datap);
	}
	if (fl == nextCar)
	  fl = readFileD2(datap);
	dd->val.pp.npoints[i][car] = j - 1;
	if (max < j - 1)
	  max = j - 1;
	car++;
      }
    }
  }
  else {
    bite_eprintf( "No \'response\' type available. (Line %ld)\n", lineno);
    bite_exit(1);
  }
  for (car = 0; car < dd->stor; car++) {
    dd->distr.pp.points[car] = malloc(max * sizeof(d));
    dd->distr.pp.npoints[car] = max;
    for (j = 0; j < max; j++)
      dd->distr.pp.points[car][j] = NULL;
  }
  fclose(datap);
}

covNode *findCov(ct c, char *name)
{
  long i = 0;

  while (strcmp(c->cList[i][0]->name, name))
    i++;

  return c->cList[i];
}

double *covLevels(ct c, char *name, long ind, long *nval, double *values)
{
  long i = 0, j, k, n = 0, car = 0, diff, stop = FALSE, stor = 1;
  double work = missing;

  if (!values)
    values = malloc(stor * sizeof(missing));
  while (strcmp(c->cList[car][0]->name, name))
    car++;
  for (i = 0; i < ind; i++) {
    k = 0;
    stop = FALSE;
    while (!stop) {
      switch (c->cList[car][0]->type) {
      case COV_CNST:
	work = c->cList[car][i]->x->x->x;
	stop = TRUE;
	break;
      case COV_SF:
	work = c->cList[car][i]->x->x->f->levels[k];
	k++;
	if (k == c->cList[car][i]->x->x->f->n - 1)
	  stop = TRUE;
	break;
      case COV_START:
	stop = TRUE;
	break;
      }
      if (c->pList[car]) {
	switch (c->pList[car]->type) {
	case COV_CNST2:
	  work = c->pList[car]->val.x[i];
	  stop = TRUE;
	  break;
	case COV_START2:
	  work = c->pList[car]->val.x2[i][k];
	  k++;
	  if (k >= c->pList[car]->n2[i])
	    stop = TRUE;
	  break;
	}
      }
      diff = 1;
      for (j = 0; j < n; j++)
	if (values[j] == work)
	  diff = 0;
      if (diff && work != missing) {
	long k;
	/* values[n] = work; */
	for (j = 0; j < n && values[j] < work; j++);
	n++;
	if (n == stor) {
	  values = realloc(values, 2 * stor * sizeof(missing));
	  stor = 2 * stor;
	}
	for (k = n; k > j; k--)
	  values[k] = values[k - 1];
	values[j] = work;
	/* if (n == ind + 1) {
	  bite_printf("Too many levels for a covariate!\n");
	  bite_exit(1);
	} */
      }
    }
  }
  *nval = n;
  return values;
}

void loadCov(char *fileName, char *name, long ind, long type, long nextI, 
	     covNode *cn)
{
  FILE *covp;
  long i, j;
  double x, y;
  double fl;
  prior last, next;

  if ((covp = bite_fopen(fileName, "r")) == NULL) {
    bite_printf("Unable to open file %s\n", fileName);
    bite_exit(1);
  }

  if (c->pList[c->n] == NULL) {
    for (i = 0; i < ind; i++) {
      strcat(cn[i]->name, name);
      cn[i]->ind = i;
      cn[i]->type = type;
      switch (type) {
      case COV_CNST:
	fl = readFileD2(covp); /* Was: &lf */
	cn[i]->x = initPrior("");
	cn[i]->x->ptype = PT_CONST;
	cn[i]->x->x->x = (double)fl;
	if (cn[i]->x->x->x != missing)
	  cn[i]->x->fixed = TRUE;
	break;
      case COV_SF:
	fl = readFileD2(covp);
	x = (double)fl;
	if (x != nextI) {
	  readFileD2(covp);
	  y = (double)fl;
	  if (y != nextI) {
	    cn[i]->x = initPrior("");
	    cn[i]->x->x->f = initSf(x, y, NULL);
	    cn[i]->x->ptype = PT_SF;
	    do {
	      readFileD2(covp);
	      x = (double)fl;
	      readFileD2(covp);
	      y = (double)fl;
	      addNode(cn[i]->x->x->f, cn[i]->x->x->f->n, x, y);
	    } while (y != nextI);
	  }
	}
	break;
      case COV_START:
	fl = readFileD2(covp);
	cn[i]->x = initPrior("");
	cn[i]->x->ptype = PT_VECTOR;
	cn[i]->x->x->vec = last = NULL;
	while ((double)fl != nextI) {
	  next = initPrior("start");
	  next->ptype = PT_CONST;
	  next->x->x = (double)fl;
	  if ((double)fl != missing)
	    next->fixed = TRUE;
	  if (!last)
	    cn[i]->x->x->vec = last = next;
	  else {
	    putPrior(last, next);
	    last = next;
	  }
	  fl = readFileD2(covp);
	}
	break;
      }
    }
  }
  else {
    strcat(c->cList[c->n][0]->name, name);
    c->pList[c->n]->name = malloc(strlen(name) + 1);
    sprintf(c->pList[c->n]->name, "%s", name);
    c->cList[c->n][0]->ind = 0;
    c->cList[c->n][0]->type = type;

    c->pList[c->n]->n = ind;
    c->pList[c->n]->type = type;
    switch (type) {
    case COV_CNST2:
      c->pList[c->n]->val.x = malloc(ind * sizeof(missing));
      c->pList[c->n]->fixed.x = malloc((ind / LONGLEN + 1) * sizeof(i));
      c->pList[c->n]->distr.x = NULL;
      break;
    case COV_START2:
      c->pList[c->n]->stor = 1;
      c->pList[c->n]->distr.x2 = malloc(c->pList[c->n]->stor * sizeof(c));
      for (i = 0; i < c->pList[c->n]->stor; i++)
	c->pList[c->n]->distr.x2[i] = NULL;

      c->pList[c->n]->n2 = malloc(ind * sizeof(i));
      c->pList[c->n]->val.x2 = malloc(ind * sizeof(c));
      c->pList[c->n]->fixed.x2 = malloc(ind * sizeof(c));
      for (i = 0; i < ind; i++) {
	c->pList[c->n]->n2[i] = 0;
	c->pList[c->n]->val.x2[i] =
	  malloc(c->pList[c->n]->stor * sizeof(missing));
	c->pList[c->n]->fixed.x2[i] =
	  malloc((c->pList[c->n]->stor / LONGLEN + 1) * sizeof(i));
      }
      break;
    }
    for (i = 0; i < ind; i++) {
      switch (type) {
      case COV_CNST2:
	c->pList[c->n]->val.x[i] = readFileD2(covp);
	if (c->pList[c->n]->val.x[i] != missing)
	  putBitTo1(i % LONGLEN, &c->pList[c->n]->fixed.x[i / LONGLEN]);
	else
	  putBitTo0(i % LONGLEN, &c->pList[c->n]->fixed.x[i / LONGLEN]);
	break;
      case COV_START2:
	fl = readFileD2(covp);
	while (fl != nextI) {
	  c->pList[c->n]->val.x2[i][c->pList[c->n]->n2[i]] = fl;
	  if (fl != missing)
	    putBitTo1(c->pList[c->n]->n2[i] % LONGLEN,
		      &c->pList[c->n]->fixed.x2[i]
		      [c->pList[c->n]->n2[i] / LONGLEN]);
	  else
	    putBitTo0(c->pList[c->n]->n2[i] % LONGLEN,
		      &c->pList[c->n]->fixed.x2[i]
		      [c->pList[c->n]->n2[i] / LONGLEN]);
	  c->pList[c->n]->n2[i]++;
	  if (c->pList[c->n]->n2[i] == c->pList[c->n]->stor) {
	    c->pList[c->n]->stor++;
	    c->pList[c->n]->distr.x2 =
	      realloc(c->pList[c->n]->distr.x2,
		      c->pList[c->n]->stor * sizeof(c));
	    c->pList[c->n]->distr.x2[c->pList[c->n]->stor - 1] = NULL;
	    for (j = 0; j < ind; j++) {
	      c->pList[c->n]->val.x2[j] =
		realloc(c->pList[c->n]->val.x2[j],
			c->pList[c->n]->stor * sizeof(missing));
	      c->pList[c->n]->fixed.x2[j] =
		realloc(c->pList[c->n]->fixed.x2[j],
			(c->pList[c->n]->stor / LONGLEN + 1) * sizeof(i));
	    }
	  }
	  fl = readFileD2(covp);
	}
	break;
      }
    }
  }
  fclose(covp);
}

void simData(long mark, long type, long ind, long car, 
	     double begin, double end, dt d)
{
  long i;

  for (i = 0; i < ind; i++) {
    d->dList[mark][i][car]->ind = i;
    d->dList[mark][i][car]->car = car;
    d->dList[mark][i][car]->mark = mark;
    d->dList[mark][i][car]->type = type;
    d->dList[mark][i][car]->begin = begin;
    d->dList[mark][i][car]->end = end;
    d->dList[mark][i][car]->nObs = 0;
  }
}

void printCov(ct c, char *name, long ind)
{
  long i, car = 0;
  prior ptr;

  while (strcmp(c->cList[car][0]->name, name))
    car++;
  for (i = 0; i < ind; i++) {
    bite_printf("%ld: ", i);
    switch (c->cList[car][i]->type) {
    case COV_CNST:
      bite_printf("%g\t", c->cList[car][i]->x->x->x);
      break;
    case COV_SF:
      printSf(c->cList[car][i]->x->x->f);
      break;
    case COV_START:
      ptr = c->cList[car][i]->x->x->vec;
      while (ptr) {
	bite_printf("%g, ", paramValue(ind, ptr));
	ptr = ptr->next;
      }
      bite_printf("\n");
      break;
    }
  }
  bite_printf("\n");
}

void addData(dataNode d, double val)
{
  long i, m;

  if (d->type == CONT) {
/*    if (!d->cData) {
      d->cData = malloc(20 * sizeof(x));
      d->storage = 20;
    }
    d->cData[d->nObs] = val;
    d->nObs++;
    if (d->nObs == d->storage) {
      vector = malloc(2 * d->storage * sizeof(val));
      for (k = 0; k < d->storage; k++)
	vector[k] = d->cData[k];
      free(d->cData);
      d->cData = vector;
      d->storage = 2 * d->storage;
    } */
  }
  else {
    if (!d->dData) {
      d->dData = malloc(2 * sizeof(i));
      if (d->type == DISCR3)
	d->times = malloc(2 * sizeof(i));
      d->storage = 2;
    }
    m = (long)val;
    d->dData[d->nObs] = m;
    d->nObs++;
    if (d->nObs == d->storage) {
      d->dData = realloc(d->dData, 2 * d->storage * sizeof(m));
      if (d->type == DISCR3)
	d->times = realloc(d->times, 2 * d->storage * sizeof(val));
      d->storage *= 2;
    }
  }
}

dataNode **initData(long ind, long dim)
{
  dataNode **d;
  long i, j;

  d = (dataNode **) malloc( (ind + 1) * sizeof( d ) );
  for (i = 0; i < ind + 1; i++) {
    d[i] = (dataNode *) malloc( dim * sizeof( d ) );
    for (j = 0; j < dim; j++) {
      d[i][j] = (dataNode) malloc( sizeof( dN ) );
      d[i][j]->name[0] = '\0';
      d[i][j]->type = NONE;
      d[i][j]->ind = i;
      d[i][j]->car = j;
      d[i][j]->formatBot = NULL;
      d[i][j]->formatTop = NULL;
/*      d[i][j]->cData = NULL; */
      d[i][j]->dData = NULL;
      d[i][j]->times = NULL;
      d[i][j]->pp = NULL;
    }
  }
  return( d );
}

paramVector initData2(long ind, long dim)
{
  paramVector d;
  long i, j;

  d = malloc( sizeof( ParamVector ) );
  d->n = ind;
  d->stor = dim;
  d->type = CONT;
  d->n2 = malloc(ind * sizeof(i));
  d->val.pp.npoints = malloc(ind * sizeof(d));
  d->val.pp.nstor = malloc(ind * sizeof(d));
  d->val.pp.t0 = malloc(ind * sizeof(d));
  d->val.pp.t1 = malloc(ind * sizeof(d));
  d->val.pp.points = malloc(ind * sizeof(d));

  d->distr.pp.npoints = malloc(dim * sizeof(d));
  d->distr.pp.t0 = malloc(dim * sizeof(d));
  d->distr.pp.t1 = malloc(dim * sizeof(d));
  d->distr.pp.points = malloc(dim * sizeof(d));

  d->fixed.pp.t0 = malloc(ind * sizeof(d));
  d->fixed.pp.t1 = malloc(ind * sizeof(d));
  d->fixed.pp.points = malloc(ind * sizeof(d));

  for (j = 0; j < dim; j++) {
    d->distr.pp.npoints[j] = 1;
    d->distr.pp.t0[j] = NULL;
    d->distr.pp.t1[j] = NULL;
    d->distr.pp.points[j] = malloc(1 * sizeof(d));
  }

  for (i = 0; i < ind; i++) {
    d->n2[i] = 1;
    d->val.pp.npoints[i] = malloc(dim * sizeof(i));
    d->val.pp.nstor[i] = malloc(dim * sizeof(i));
    d->val.pp.t0[i] = malloc(dim * sizeof(missing));
    d->val.pp.t1[i] = malloc(dim * sizeof(missing));
    d->val.pp.points[i] = malloc(dim * sizeof(d));

    d->fixed.pp.t0[i] = malloc(dim * sizeof(d));
    d->fixed.pp.t1[i] = malloc(dim * sizeof(d));
    d->fixed.pp.points[i] = malloc(dim * sizeof(d));
    
    for (j = 0; j < dim; j++) {
      d->val.pp.npoints[i][j] = 0;
      d->val.pp.nstor[i][j] = dim;
      d->val.pp.points[i][j] = NULL;

      d->fixed.pp.t0[i][j] = FALSE;
      d->fixed.pp.t1[i][j] = FALSE;
      d->fixed.pp.points[i][j] = NULL;
    }
  }
  return( d );
}

dt initDataTree(long storage)
{
  long i;
  dt res;

  res = (dt) malloc( sizeof( jackdt) );
  res->n = 0;
  res->storage = storage;
  res->nCars = (long *) malloc(storage * sizeof(i));
  res->dList = (dataNode ***) malloc( storage * sizeof( res ) );
  res->pList = (paramVector *) malloc( storage * sizeof( res ) );
  for (i = 0; i < storage; i++) {
    res->dList[i] = NULL;
    res->pList[i] = NULL;
    res->nCars[i] = 0;
  }

  return( res );
}

covNode *initCov(long ind)
{
  covNode *c;
  long i;

  c = (covNode *) malloc( (ind + 1) * sizeof( c ) );
  for (i = 0; i < ind + 1; i++) {
    c[i] = (covNode) malloc( sizeof( cN ) );
    c[i]->ind = i;
    c[i]->name[0] = '\0';
    c[i]->type = NONE;
    c[i]->x = NULL;
/*    c[i]->cnst = NULL;
    c[i]->f = NULL;
    c[i]->n = 0;
    c[i]->sp = NULL; */
  }
  return( c );
}

ct initCovTree(long storage)
{
  long i;
  ct res;

  res = (ct) malloc( sizeof( jackct) );
  res->n = 0;
  res->storage = storage;
  res->cList = (covNode **) malloc( storage * sizeof( res ) );
  res->pList = malloc( storage * sizeof( res ) );
  res->nval = (long *) malloc( storage * sizeof( i ) );
  res->values = (double **) malloc( storage * sizeof( res ) );
  res->labels = (char ***) malloc(storage * sizeof(res));
  for (i = 0; i < storage; i++) {
    res->cList[i] = NULL;
    res->nval[i] = 0;
    res->values[i] = NULL;
    res->labels[i] = NULL;
  }

  return( res );
}

#endif
