/* Tommi Harkanen (C) 2000 */
/* Read the file copyright.txt for details */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include "typedef.h"

/* A new version of 'pipefiles': trying to produce only a few text files
   containing values of some (similar) parameters. */

static long nfiles = 0, storage = 0;
static long *file = NULL;
static char **filenames = NULL;
static FILE **fp = NULL;

long openFile(char *filename, char type)
{
  long i = 0;
  char dum, t[2];

  while (i < nfiles && strcmp(filenames[i], filename))
    i++;
  if (i == nfiles) {
    /* Open a new file. */
    if (nfiles == storage) {
      /* Allocate more memory for the files. */
      if (!file) {
	/* No files open yet. */
	storage = 5;
	file = malloc(storage * sizeof(file));
	filenames = malloc(storage * sizeof(file));
	fp = malloc(storage * sizeof(file));
      }
      else {
	/* Reallocate more space. */
	storage++;
	file = realloc(file, storage * sizeof(file));
	filenames = realloc(filenames, storage * sizeof(file));
	fp = realloc(fp, storage * sizeof(file));
      }
    }
    t[0] = type;
    t[1] = '\0';
    if (!(fp[i] = bite_fopen(filename, t))) {
      bite_eprintf("Couldn't open file %s.\n", filename);
      bite_exit(1);
    }
    filenames[i] = malloc((strlen(filename) + 1) * sizeof(dum));
    sprintf(filenames[i], "%s", filename);
    filenames[i][strlen(filename)] = '\0';
    nfiles++;
  }

  return i; /* File id. */
}

double readFileD2(FILE *fp)
{
  double res;
  int val = 0;
  char ch = '\0';

  /* while (!feof(fp) && ((ch = fgetc(fp)) == ' ' ||
			  ch == '\t' || ch == '\n' || ch == '#'))
			  if (ch == '#')
      while ((ch = fgetc(fp)) != '\n');
  if (feof(fp) && ch) {
    rewind(fp);
    res = readFileD(file);
  }
  else {
    ungetc(ch, fp);
    fscanf(fp, "%lf", &res);
  } */

  
  while ((val = fscanf(fp, "%lf", &res)) == 0 || val == EOF) {
    if (!val)
      while ((ch = fgetc(fp)) != '\n');
    if (feof(fp))
      rewind(fp);
  }

  return res;
}

double readFileD(long file)
{
  double res;

  /* bite_printf("R %ld\n", file); */
  res = readFileD2(fp[file]);
  /* bite_printf("\t%g\n", res); */

  return res;
}

void writeFileS(long file, char *argstr)
{
  fprintf(fp[file], "%s", argstr);
  fflush(fp[file]);
}

void closeAllFiles()
{
  long i;

  for (i = 0; i < nfiles; i++)
    fclose(fp[i]);
}

